﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections.Generic;
using System.Windows;

using MindFusion.Reporting.Wpf.Export;

using Microsoft.Win32;


namespace MindFusion.Reporting.Wpf.Samples.CS.LineChart
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			report = Report.FromDictionary(new Uri("report.xaml", UriKind.Relative), "chartReport");
			report.Run();

			var layout = report.Layout(new Size(8.5 * 96, 11 * 96), new Thickness(0.5 * 96), PageOrientation.Landscape);

			var renderTarget = new FixedDocumentRenderTarget();
			layout.RenderAllPages(renderTarget);

			viewer.Document = renderTarget.Document;
		}

		private void MenuItem_Click(object sender, RoutedEventArgs e)
		{
			var dialog = new SaveFileDialog();
			dialog.Filter = "PDF Files (*.pdf)|*.pdf|All files|*.*||";
			if (dialog.ShowDialog() == true)
			{
				var exporter = new PdfExporter();
				exporter.PageOrientation = PageOrientation.Landscape;
				exporter.Export(report, dialog.FileName);
			}
		}

		private void MenuItem_Click_1(object sender, RoutedEventArgs e)
		{
			Close();
		}


		private Report report;
	}

	public class Chart1DataCollection : List<ChartData>
	{
		public Chart1DataCollection()
		{
			// Initialize the collection with random data
			Random r = new Random(DateTime.Now.Millisecond);
			int from = 1995;
			int to = 2015;

			double y1 = r.NextDouble() * 1000 + 500;
			double y2 = r.NextDouble() * 1000 + 500;
			double y3 = r.NextDouble() * 1000 + 500;
			double y4 = r.NextDouble() * 1000 + 500;
			for (int i = from; i <= to; i++)
			{
				Add(new ChartData { XData = new DateTime(i, 1, 1).ToOADate(), Y1Data = y1, Y2Data = y2, Y3Data = y3, Y4Data = y4 });

				y1 += (r.NextDouble() * 300) - 100;
				y2 += (r.NextDouble() * 300) - 100;
				y3 += (r.NextDouble() * 300) - 100;
				y4 += (r.NextDouble() * 300) - 100;
			}
		}
	}

	public class ChartData
	{
		public object XData
		{
			get;
			set;
		}

		public object Y1Data
		{
			get;
			set;
		}

		public object Y2Data
		{
			get;
			set;
		}

		public object Y3Data
		{
			get;
			set;
		}

		public object Y4Data
		{
			get;
			set;
		}
	}
}
